Package: looking4clusters
Type: Package
Version: 1.2.0
Date: 2025-10-01
Title: Interactive Visualization of scRNA-Seq
Description: Enables the interactive visualization of dimensional
    reduction, clustering, and cell properties for scRNA-Seq results. It
    generates an interactive HTML page using either a numeric matrix,
    SummarizedExperiment, SingleCellExperiment or Seurat objects as input.
    The input data can be projected into two-dimensional representations by
    applying dimensionality reduction methods such as PCA, MDS, t-SNE, UMAP,
    and NMF. Displaying multiple dimensionality reduction results within the
    same interface, with interconnected graphs, provides different perspectives
    that facilitate accurate cell classification. The package also integrates
    unsupervised clustering techniques, whose results that can be viewed
    interactively in the graphical interface. In addition to
    visualization, this interface allows manual selection of groups,
    labeling of cell entities based on processed meta-information,
    generation of new graphs displaying gene expression values for each
    cell, sample identification, and visual comparison of samples and
    clusters.
License: GPL-2 | GPL-3
Depends: R (>= 4.5.0)
Imports: stats, utils, SummarizedExperiment, SingleCellExperiment,
        BiocBaseUtils, jsonlite
Suggests: knitr, rmarkdown, Seurat, parallelDist, uwot, NMF, fpc,
        dendextend, cluster, Rtsne, scRNAseq, Matrix
VignetteBuilder: knitr
NeedsCompilation: no
biocViews: Software, Visualization, DataRepresentation, GeneExpression,
        MultipleComparison, Classification, Clustering
BugReports: https://github.com/BioinfoUSAL/looking4clusters/issues/
URL: https://github.com/BioinfoUSAL/looking4clusters/
Authors@R: c( 
    person("David", "Barrios", email = "metal@usal.es", role = c("aut", "cre"), comment = c(ORCID = "0000-0003-4465-0200")),
    person("Angela", "Villaverde", email = "angelavr@usal.es", role = "aut", comment = c(ORCID = "0000-0002-7337-7218")),
    person("Carlos", "Prieto", email = "cprietos@usal.es", role = "aut", comment = c(ORCID = "0000-0001-8178-9768"))
    )
git_url: https://git.bioconductor.org/packages/looking4clusters
git_branch: RELEASE_3_23
git_last_commit: 3c87dce
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-28 22:58:42 UTC; biocbuild
Author: David Barrios [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-4465-0200>),
  Angela Villaverde [aut] (ORCID:
    <https://orcid.org/0000-0002-7337-7218>),
  Carlos Prieto [aut] (ORCID: <https://orcid.org/0000-0001-8178-9768>)
Maintainer: David Barrios <metal@usal.es>

# looking4clusters
Applies dimension reduction and clustering techniques and creates interactive clustering visualization plots.

# Install

```r
# installing from bioconductor
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("looking4clusters")

# installing from github
library(devtools)
install_github('BioinfoUSAL/looking4clusters')
```

# Usage

```r
library(looking4clusters)
library(scRNAseq)
sce <- ReprocessedAllenData("tophat_counts")
counts <- t(assays(sce)$tophat_counts)

obj <- looking4clusters(counts, groups=colData(sce)[,'dissection_s'])
l4chtml(obj)
```

## Input Vars
# distance: the distance measure to be used. This must be one of "euclidean",
# "maximum", "manhattan", "canberra", "binary" or "minkowski".
# agglomeration: the agglomeration method to be used.  This should be one of
# "ward.D", "ward.D2", "single", "complete", "average", "mcquitty", "median" or
# "centroid".
# selectedk: Number of clusters selected by the user. If 'NULL', default values
# are used (kmin=2,kmax=10), else, a rank of 5 units around 'selectedk' is
# calculated .
##

run_pam_hclust <- function(object, distance="euclidean",
        agglomeration="complete", selectedk=NULL, threads=NULL){
    if(requireNamespace("fpc",quietly=TRUE)){

data <- object$data

if(is.null(selectedk)){
    kmin<-2
    kmax<-10
}else{
    kmin<-(selectedk-5)
    kmax<-(selectedk+5)
}

if(kmin <= 1){
    kmin <- 2
}
if(kmax >= nrow(data)){
    kmax <- nrow(data)-1
}
if(kmin >= kmax){
    kmin <- kmax-1
}

iter <- kmax-kmin+1

dissimilarity <- get_dissimilarity(distance,data,threads)

pamresults <- run_pam(selectedk,dissimilarity,kmin,kmax,iter,data)
allClassfPam <- pamresults[[1]]
numberClustersPAM <- pamresults[[2]]

hclustresults <- run_hclust(agglomeration,dissimilarity,
    kmin,kmax,selectedk,iter)
Hclusters <- hclustresults[[1]]
numberClustersHclust <- hclustresults[[2]]

object <- clustering_tables(object,iter,allClassfPam,numberClustersPAM,
    Hclusters,numberClustersHclust)

    }else{
        warning("Install 'fpc' to get pam and hclust clusters.")
    }
    return(object)
}

run_pam <- function(selectedk,dissimilarity,kmin,kmax,iter,data){
## PAM:
allClassfPam <- NULL
numberClustersPAM <- NULL
if(requireNamespace("cluster",quietly=TRUE)){
    if(is.null(selectedk)){
        # Calinski Harabasz
        pamk<-fpc::pamk(dissimilarity, krange=kmin:kmax, criterion="ch",
            usepam=TRUE, scaling=FALSE, diss=TRUE)
        numberClustersPAM<-pamk$nc
    }else{
        numberClustersPAM <- selectedk
    }

    # All clusters 
    all.pam <- lapply(kmin:kmax, function(k){
        cluster::pam(dissimilarity, k, diss=TRUE, cluster.only=FALSE,
            keep.diss=FALSE, keep.data=FALSE)
    })

    allClassfPam <- vapply(seq_len(iter),function(k){
        all.pam[[k]]$clustering
    }, integer(nrow(data)))

# Explanation of any default parameters: 
# criterion: "ch" = calinski Harabasz index
# usepam: If TRUE, PAM clustering method is applied, else, CLARA clustering
# method is computed. 
# diss: Are input data a dissimilarity matrix?
# scaling: After calculate the dissimilarity matrix, Want to scale it?
# cluster.only: If TRUE, only the clustering will be computed and returned
}else{
    warning("Install 'cluster' to get pam clusters.")
}
return(list(allClassfPam,numberClustersPAM))
}

get_dissimilarity <- function(distance,data,threads){
    # Calculate dissimilarity matrix (parallel)
    if(!(distance %in% c("euclidean", "maximum", "manhattan",
            "canberra", "binary", "minkowski"))){
        distance <- "euclidean"
    }
    if(requireNamespace("parallelDist",quietly=TRUE)){
        dissimilarity <- parallelDist::parDist(data,
            method=distance, threads=threads)
    }else{
        dissimilarity <- dist(data,method=distance)
    }
    return(dissimilarity)
}

run_hclust <- function(agglomeration,dissimilarity,kmin,kmax,selectedk,iter){
## HCLUST:
Hclusters <- NULL
numberClustersHclust <- NULL
if(requireNamespace("dendextend",quietly=TRUE)){

if(!(agglomeration %in% c("ward.D", "ward.D2", "single", "complete",
        "average", "mcquitty", "median", "centroid")))
    agglomeration <- "complete"
hierarchical<-hclust(dissimilarity,method = agglomeration)
Hclusters<-dendextend::cutree(hierarchical,k=seq(kmin,kmax,1))

if(is.null(selectedk)){
    # Calinski Harabasz
    chIndex<-numeric()
    for(i in seq_len(iter))
        chIndex[i] <- fpc::cluster.stats(d = dissimilarity,
            clustering = Hclusters[,i])$ch
    numberClustersHclust<-(which(chIndex==max(chIndex))+kmin-1)
}else{
    numberClustersHclust <- selectedk
}

}else{
    warning("Install 'dendextend' to get hclust clusters.")
}
return(list(Hclusters,numberClustersHclust))
}

clustering_tables <- function(object,iter,allClassfPam,numberClustersPAM,
    Hclusters,numberClustersHclust){
# Clustering tables

for(i in seq_len(iter)){
    if(length(allClassfPam)){
        clusters <- as.factor(paste0("pam_",allClassfPam[,i]))
        optim_cluster <- FALSE
        if(length(levels(clusters))==numberClustersPAM){
            optim_cluster <- TRUE
        }
        object <- addcluster(object, clusters,
            "pam", optim_cluster = optim_cluster)
    }
    if(length(Hclusters)){
        clusters <- as.factor(paste0("hclust_",Hclusters[,i]))
        optim_cluster <- FALSE
        if(length(levels(clusters))==numberClustersHclust){
            optim_cluster <- TRUE
        }
        object <- addcluster(object, clusters, "hclust",
            optim_cluster = optim_cluster)
    }
}

# 'numberClustersPAM' and 'numberClustersHclust' are the default number of
# clusters values to represent in the graphs if automatic mode is select, else,
# 'selectedk' is used.
return(object)
}

run_umap <- function(object){
    if(requireNamespace("uwot", quietly=TRUE)){
        data <- object$data
        n_neighbors <- 15
        if(n_neighbors>(nrow(data)/3)){
            n_neighbors <- floor(nrow(data)/3)
        }
        if(n_neighbors < 2){
            n_neighbors <- 2
        }
        UMAPcomponents <- uwot::umap(data, n_neighbors = n_neighbors)
        colnames(UMAPcomponents) <- c("UMAP1","UMAP2")
        object <- addreduction(object,UMAPcomponents,"umap")
    }else{
        warning("Install 'uwot' to get umap dimensionality reduction.")
    }
    return(object)
}

l4c_Seurat <- function(object, assay = NULL){
    BiocBaseUtils::checkInstalled("Seurat")

    joinassays <- FALSE
    if(is.null(assay)){
        assay <- Seurat::DefaultAssay(object)
    }else if(!(assay %in% Seurat::Assays(object))){
        if(assay=="all"){
            joinassays <- TRUE
            assay <- Seurat::DefaultAssay(object)
        }else{
            stop("assay: wrong assay especified")
        }
    }

    l4c <- create_l4c(get_scale_data(object,assay,joinassays))

    l4c <- seurat_reductions(l4c,object)


    l4c <- seurat_clusters(l4c,object)

    return(l4c)
}

get_scale_data <- function(object,assay,joinassays){
    counts <- Seurat::GetAssayData(object, layer="counts", assay=assay)
    data <- Seurat::GetAssayData(object, layer="scale.data", assay=assay)
    if(!length(data)){
        stop(
"No layer matching pattern 'scale.data' found. Please run ScaleData and retry"
        )
    }

    if(joinassays){
        for(a in setdiff(Seurat::Assays(object),assay)){
            assaycounts <-
                Seurat::GetAssayData(object, layer="counts", assay=a)
            rownames(assaycounts) <- paste0(rownames(assaycounts),"_",a)
            counts <- rbind(counts, assaycounts)
            assaysdata <-
                Seurat::GetAssayData(object, layer="scale.data", assay=a)
            if(!length(assaysdata)){
                text <- paste0("No layer matching pattern 'scale.data' found ",
                "for '",a,"' assay. Please run ScaleData and retry")
                stop(text)
            }
            rownames(assaysdata) <- paste0(rownames(assaysdata),"_",a)
            data <- rbind(data,assaysdata)
        }
    }

    counts <- t(data.matrix(counts))
    keep <- counts!=0

    data <- t(data.matrix(data))
    data[!keep] <- NA
    return(data)
}

seurat_reductions <- function(l4c,object){
    if('reductions' %in% names(attributes(object))){
        for(reduction in names(object@reductions)){
            mat <- Seurat::Embeddings(object,
                reduction = reduction)[, seq_len(2)]
            l4c <- addreduction(l4c,mat,reduction)
        }
    }
    return(l4c)
}

seurat_clusters <- function(l4c,object){
    if('meta.data' %in% names(attributes(object))){
        for(name in names(object@meta.data)){
            clusters <- object[[name]]
            if(is.data.frame(clusters)){
                if(name %in% names(clusters)){
                    clusters <- clusters[,name]
                }else{
                    next
                }
            }
            if(is.numeric(clusters) || is.factor(clusters)){
                clusters <- as.character(clusters)
            }
            if(!is.character(clusters) ||
                    length(clusters)!=length(l4c$samples)){
                next
            }
            l4c <- addcluster(l4c, clusters,
                name=gsub(".","_",name,fixed=TRUE), groupStatsBy=TRUE)
        }
    }
    return(l4c)
}

l4c_SCE <- function(object, groups = NULL, assay = NULL){
    if(!is.null(assay)){
        data <- t(SummarizedExperiment::assay(object,assay))
    }else{
        data <- t(SummarizedExperiment::assay(object))
    }

    l4cObject <- create_l4c(data)

    rdnames <- SingleCellExperiment::reducedDimNames(object)
    if(length(rdnames)){
        for(n in rdnames){
            rd <- SingleCellExperiment::reducedDim(object,n)
            l4cObject <- addreduction(l4cObject,rd,n)
        }
    }

    coldata <- SummarizedExperiment::colData(object)
    if(ncol(coldata)){
        if(!is.null(groups)){
            l4cObject <- addcluster(l4cObject,coldata[,groups],myGroups=TRUE)
        }
        for(n in colnames(coldata)){
            l4cObject <- addcluster(l4cObject, coldata[,n],
                name=n, groupStatsBy=TRUE)
        }
    }

    return(l4cObject)
}

## Input Vars
# perplex: numeric. Perplexity parameter (should not be bigger than
# 3 * perplexity < nrow(X)-1). This value effectively controls how many nearest
# neighbours are taken into account when constructing the embedding in the
# low-dimensional space (default: 30)
# maxIter: integer. Number of iterations (default: 1000)
##

run_tsne <- function(object,perplex=30,maxIter=1000){
    if(requireNamespace("Rtsne",quietly=TRUE)){
        data <- object$data
        if(3 * perplex > nrow(data)-1){
            perplex <- (nrow(data)-1)/3
        }
        tSNEcomponents <- Rtsne::Rtsne(data, dims=2, perplexity=perplex,
            verbose=FALSE, check_duplicates=FALSE, max_iter=maxIter)
        tsne <- tSNEcomponents$Y
        colnames(tsne) <- c("tSNE1","tSNE2")
        object <- addreduction(object,tsne,"tsne")
    }else{
        warning("Install 'Rtsne' to get tsne dimensionality reduction.")
    }
    return(object)
}

wwwDirectory <- function(){
    path <- system.file("www",package="looking4clusters")
    return(path)
}

adjacency <- function(x){
    if(is.numeric(x)){
        source <- rep(seq_len(nrow(x))-1,ncol(x))
        target <- rep(seq_len(ncol(x))-1,rep(nrow(x),ncol(x)))
        value <- signif(as.vector(x),3)
        return(cbind(source,target,value))
    }
}

clean_names <- function(name){
    return(gsub("[^A-Za-z0-9]","_",name))
}

indexfile <- function(directory){
    return(file.path(directory,"index.html"))
}

create_l4c_directory <- function(directory){
    if(file.exists(directory)){
        stoptext <- paste0("directory: '",directory,"' already exists")
        if(file.exists(indexfile(directory))){
            content <- scan(file = indexfile(directory), what = character(0),
                sep = "\n", quiet = TRUE)
            if(sum(content=="<!-- BioinfoUSAL looking4clusters -->")==1){
                unlink(directory, recursive = TRUE)
            }else{
                stop(stoptext)
            }
        }else{
            stop(stoptext)
        }
    }
    dir.create(directory)
}

## Input Vars
# selectedk: Number of clusters selected by the user.
# If 'NULL', default values are used (kmin=2,kmax=10), else, a rank of 5 units
# around 'selectedk' is calculated
##

run_kmeans <- function(object,selectedk=NULL){

data <- object$data

if(is.null(selectedk)){
    kmin<-2
    kmax<-10
}else{
    kmin<-(selectedk-5)
    kmax<-(selectedk+5)
}

if(kmin <= 1)
    kmin <- 2
if(kmax >= nrow(data))
    kmax <- nrow(data)-1
if(kmin >= kmax)
    kmin <- kmax-1

iter<-kmax-kmin+1

# kmeans (applied for all selected 'k' values)
all.kmeans<-lapply(kmin:kmax, function(k){
    kmeans(data, k, nstart=1 ,iter.max = 15)
})

if(is.null(selectedk)){
    numberClustersKmeans <- calinski_harabasz_index(iter,
        all.kmeans,nrow(data),kmin)
}else{
    numberClustersKmeans <- selectedk
}

# Clustering table

for(i in seq_len(iter)){
    clusters <- as.factor(paste0("kmeans_",all.kmeans[[i]]$cluster))
    optim_cluster <- FALSE
    if(length(levels(clusters))==numberClustersKmeans){
        optim_cluster <- TRUE
    }
    object <- addcluster(object,clusters,"kmeans",optim_cluster=optim_cluster)
}

return(object)

# 'numberClustersKmeans' is the default number of clusters values to represent
# in the graphs if automatic mode is select, else, 'selectedk' is used. 
}

calinski_harabasz_index <- function(iter,all.kmeans,N,kmin){
    # Calinski-Harabasz Index
    SSw <- vapply(seq_len(iter), function(x){
        all.kmeans[[x]]$tot.withinss
    },numeric(1))
    SSb <- vapply(seq_len(iter), function(x){
        all.kmeans[[x]]$betweens
    },numeric(1))
    chIndex <- vapply(seq_len(iter), function(x){
        (SSb[x]*(N-(x+kmin-1)))/(SSw[x]*((x+kmin-1)-1))
    },numeric(1))

    # Number of optimum clusters
    return(which(chIndex==max(chIndex))+kmin-1)
}

l4c <- function(data, groups = NULL, components = FALSE, running_all = TRUE,
    distance = "euclidean", agglomeration = "complete", selectedk = NULL,
    perplex = 30, maxIter = 1000, threads = NULL, force_execution = FALSE){

    if(is.null(dim(data))){
        stop("data: incorrect dimensions. A matrix like object is required.")
    }

    if(running_all && (ncol(data) > 5000 || nrow(data) > 5000)){
        if(force_execution){
            message(
"Too large matrix, could cause performance problems with some methods"
            )
        }else{
            message(
"Too large matrix, could cause performance problems with some methods,
they will be omitted"
            )
        }
    }

    object <- create_l4c(data,components)

    if(!is.null(groups)){
        object <- addcluster(object,groups,myGroups=TRUE)
    }

    if(running_all){
        object <- running_clusters(object, selectedk, data, force_execution,
            distance, agglomeration, threads)
        object <- running_reductions(object, data, force_execution,
            threads, perplex, maxIter)
    }

    return(object)
}

running_clusters <- function(object, selectedk, data, force_execution,
        distance, agglomeration, threads){

    message("Running kmeans...")
    object <- run_kmeans(object,selectedk)
    if(force_execution || !(nrow(data) > 5000)){
        message("Running pam and hclust...")
        object <- run_pam_hclust(object, distance, agglomeration,
            selectedk, threads)
    }

    return(object)
}

running_reductions <- function(object, data, force_execution,
        threads, perplex, maxIter){

    message("Running pca...")
    object <- run_pca(object)
    message("Running tsne...")
    object <- run_tsne(object,perplex,maxIter)
    if(force_execution || !(nrow(data) > 5000)){
        message("Running mds...")
        object <- run_mds(object,threads)
    }
    if(force_execution || !(ncol(data) > 5000)){
        message("Running nmf...")
        object <- run_nmf(object)
    }
    message("Running umap...")
    object <- run_umap(object)

    return(object)
}

Ncomponents <- function(variability){
    nComp <- 4
    divisor <- 10
    if(length(variability)*0.9>1){
        variability <-
            variability[seq_len(as.integer(length(variability)*0.9))]
    }

    change <- variability[-length(variability)] - variability[-1]
    propChange <-
        (mean(change)/mean(sort(change,decreasing=TRUE)[seq_len(3)]))*100
    if(propChange>10 && propChange<=15){
        divisor <- 5
    }
    if(propChange>15){
        return(nComp)
    }
    minVar <- max(change)/divisor
    CutoffCriterion <- (change<minVar)
    position <- numeric()
    for(i in seq_len(length(variability)-1)){
        if(CutoffCriterion[i]==TRUE){
            k <- k+1
        }else{
            k <- 0
        }
        position <- c(position,k)
        if(k>7 || (i>10 && k>3)){
            n <- (max(which(position==1))-1)
            if(n>1){
                nComp <- n
            }
        }
    }
    return(nComp)
}

create_l4c <- function(data,components=FALSE){

    samples <- rownames(data)
    if(is.null(samples)){
        samples <- paste0("sample_",seq_len(nrow(data)))
    }

    if(components){
        if(nrow(data)<5){
            stop(
"You cannot apply to components for less than five samples."
            )
        }
        if(ncol(data)<5){
            stop(
"You cannot apply to components for less than five variables."
            )
        }

        ldata <- log2(data+1)
        lpca <- prcomp(ldata)
        var <- summary(lpca)$importance[2,]
        nc <- Ncomponents(var)
        pca <- prcomp(data,scale=FALSE)
        data <- pca$x[,seq_len(nc)]
    }

    return(structure(list(data=data.matrix(data), samples=samples,
        variables=colnames(data), options=list()), class="looking4clusters"))
}

addreduction <- function(object, data, name=NULL){
    if(!inherits(object,"looking4clusters")){
        stop("object: must be a 'looking4clusters' object")
    }
    if(nrow(data)!=length(object$samples)){
        stop("data: there must be one row per sample")
    }
    if(!length(object$reductions)){
        object$reductions <- list()
    }
    if(is.null(name)){
        name <- paste0("reduction_",length(object$reductions)+1)
    }else{
        name <- clean_names(name)
    }
    object$reductions[[name]] <- data[,seq_len(2)]
    return(object)
}

addcluster <- function(object, data, name=NULL, groupStatsBy=FALSE,
        myGroups=FALSE, optim_cluster=FALSE){
    if(!inherits(object,"looking4clusters")){
        stop("object: must be a 'looking4clusters' object")
    }
    if(length(data)!=length(object$samples)){
        stop("data: there must be one per sample")
    }
    if(!length(object$clusters)){
        object$clusters <- list()
    }
    if(is.null(name)){
        name <- paste0("cluster_",length(object$clusters)+1)
    }else{
        name <- clean_names(name)
    }
    data <- as.factor(data)
    if(length(object$clusters[[name]])){
        if(is.factor(object$clusters[[name]])){
            object$clusters[[name]] <-
                data.frame(V1=object$clusters[[name]],V2=data)
            colnames(object$clusters[[name]]) <-
                vapply(object$clusters[[name]],function(x){
                    return(paste0("levels_",length(levels(x))))
                }, character(1))
            attr(object$clusters[[name]],"optim_cluster") <-
                length(levels(object$clusters[[name]][[1]]))
        }else{
            object$clusters[[name]][[paste0("levels_",
                length(levels(data)))]] <- data
        }
        if(optim_cluster){
            attr(object$clusters[[name]], "optim_cluster") <-
                length(levels(data))
        }
    }else{
        object$clusters[[name]] <- data
    }
    if(groupStatsBy){
        object$options$groupStatsBy <- c(object$options$groupStatsBy,name)
    }
    if(myGroups){
        object$options$myGroups <- name
    }
    return(object)
}

writehtml <- function(object, includeData, directory){
    datadir <- file.path(directory,"data")
    dir.create(datadir)

    write(object$samples,file=file.path(datadir,"samples.txt"))
    if(includeData){
        write_data(object,datadir)
    }

    write_reductions(object,datadir)

    write_clusters(object,datadir)

    www <- wwwDirectory()
    file.copy(file.path(www,"css"), directory, recursive=TRUE)
    file.copy(file.path(www,"js"), directory, recursive=TRUE)
    file.copy(file.path(www,"font"), directory, recursive=TRUE)
    file.copy(file.path(www,"images"), directory, recursive=TRUE)

    html <- scan(file = file.path(www, "template.html"), what = character(0),
        sep = "\n", quiet = TRUE)
    html <- gsub("<!--name-->", basename(directory), html)

    con <- file(indexfile(directory), "a", encoding = "UTF-8")
    write(html[seq_len(which(html=="<!--data-->")-1)],con,append=TRUE)

    for(f in dir(datadir)){
        dat <- scan(file = file.path(datadir,f), what = character(0),
            sep = "\n", quiet = TRUE)
        write(c(paste0("<pre class=\"",gsub(".","_",f,fixed=TRUE),"\">"),
            dat,"</pre>"),con,append=TRUE)
    }

    write(html[(which(html=="<!--data-->")+1):length(html)],con,append=TRUE)
    close(con)

    unlink(datadir, recursive = TRUE)
}

l4chtml <- function(x, includeData = FALSE, directory = NULL){
    if(is.character(x) && file.exists(x) && grepl("\\.json$",x)){
        l4cjson(x,directory)
    }else if(inherits(x,"looking4clusters")){
        if(is.null(directory)){
            directory <- tempfile()
            dir.create(directory)
            writehtml(x, includeData, directory)
            browseURL(normalizePath(indexfile(directory)))
        }else{
            create_l4c_directory(directory)
            writehtml(x, includeData, directory)
            text <- paste0("The graph has been generated in the \"",
            normalizePath(directory),"\" path.")
            message(text)
        }
    }else{
        stop("x: must be a 'looking4clusters' object or a JSON file")
    }
}

write_data <- function(object,datadir){
    write(object$variables,file=file.path(datadir,"variables.txt"))
    adj <- adjacency(object$data)
    adj <- adj[!is.na(adj[,3]),]
    adj[,3] <- signif(adj[,3],3)
    write.table(adj, file = file.path(datadir,"data.tsv"), quote = FALSE,
        sep = "\t", row.names = FALSE, col.names = FALSE)
}

write_reductions <- function(object,datadir){
    if(length(object$reductions)){
        for(reduction in names(object$reductions)){
            write.table(signif(object$reductions[[reduction]],3),
                file=file.path(datadir,paste0(reduction,".csv")),
                row.names=FALSE,col.names=TRUE,sep=",",quote=FALSE)
        }
        write(names(object$reductions),
            file=file.path(datadir,"reductions.txt"))
    }
}

write_clusters <- function(object,datadir){
    if(length(object$clusters)){
        for(cluster in names(object$clusters)){
            cluster_data <- object$clusters[[cluster]]
            if(is.factor(cluster_data)){
                clusternames <- paste0(gsub("|",",",levels(cluster_data),
                    fixed=TRUE),collapse="|")
                samples <- paste0(as.numeric(cluster_data)-1,collapse="|")
            }else{
                clusternames <- vapply(cluster_data,function(x){
                    return(paste0(gsub("|",",",levels(x),
                        fixed=TRUE),collapse="|"))
                }, character(1))
                samples <- vapply(cluster_data,function(x){
                    return(paste0(as.numeric(x)-1,collapse="|"))
                }, character(1))
                write(attr(cluster_data,"optim_cluster"),
                    file=file.path(datadir,
                    paste0(cluster,"_optim_cluster.txt")))
            }
            write.table(data.frame(clusternames, samples),
                file = file.path(datadir, paste0(cluster, ".tsv")),
                quote = FALSE, sep = "\t",
                row.names = FALSE, col.names = FALSE)
        }
        write(names(object$clusters),file=file.path(datadir,"clusters.txt"))
        if(length(object$options$groupStatsBy)){
            write(object$options$groupStatsBy,
                file=file.path(datadir,"groupstatsby.txt"))
        }
        if(length(object$options$myGroups)){
            write(object$options$myGroups,
                file=file.path(datadir,"mygroups.txt"))
        }
    }
}

print.looking4clusters <- function(x, ...){
    cat("An object of class looking4clusters\n")
    cat(paste0(length(x$variables)," variables across ",
        length(x$samples)," samples\n"))
    if(length(x$clusters)){
        cat(paste0(length(x$clusters)," clusters added: ",
            paste0(names(x$clusters),collapse=", "),"\n"))
    }
    if(length(x$reductions)){
        cat(paste0(length(x$reductions)," dimensional reductions added: ",
            paste0(names(x$reductions),collapse=", "),"\n"))
    }
}

looking4clusters <- function(data, groups = NULL, assay = NULL,
    components = FALSE, running_all = TRUE, distance = "euclidean",
    agglomeration = "complete", selectedk = NULL, perplex = 30,
    maxIter = 1000, threads = NULL, force_execution = FALSE){
    if(inherits(data,"Seurat")){
        l4c_Seurat(data, assay)
    }else if(inherits(data,"SingleCellExperiment")){
        l4c_SCE(data, groups, assay)
    }else{
        l4c(data, groups, components, running_all,
        distance, agglomeration, selectedk,
        perplex, maxIter, threads, force_execution)
    }
}

l4cjson <- function(json, directory = NULL){
    writehtmlfromjson <- function(json,directory){
        data <- jsonlite::fromJSON(json)

        www <- wwwDirectory()
        file.copy(file.path(www,"css"), directory, recursive=TRUE)
        file.copy(file.path(www,"js"), directory, recursive=TRUE)
        file.copy(file.path(www,"font"), directory, recursive=TRUE)
        file.copy(file.path(www,"images"), directory, recursive=TRUE)

        html <- scan(file = file.path(www, "template.html"),
            what = character(0), sep = "\n", quiet = TRUE)
        html <- gsub("<!--name-->", basename(directory), html)

        con <- file(indexfile(directory), "a", encoding = "UTF-8")
        write(html[seq_len(which(html=="<!--data-->")-1)],con,append=TRUE)

        for(pre in names(data)){
            txt <- data[[pre]]
            if(!is.character(txt)){
                txt <- jsonlite::toJSON(txt)
            }
            write(c(paste0("<pre class=\"",pre,"\">"),
                txt,"</pre>"),con,append=TRUE)
        }

        write(html[(which(html=="<!--data-->")+1):length(html)],con,append=TRUE)
        close(con)
    }

    if(is.null(directory)){
        directory <- tempfile()
        dir.create(directory)
        writehtmlfromjson(json, directory)
        browseURL(normalizePath(indexfile(directory)))
    }else{
        create_l4c_directory(directory)
        writehtmlfromjson(json, directory)
        text <- paste0("The graph has been generated in the \"",
        normalizePath(directory),"\" path.")
        message(text)
    }
}

## ----echo=TRUE, message=FALSE, warning=FALSE, eval=FALSE----------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("looking4clusters")

## ----echo=TRUE, message=FALSE, warning=FALSE, eval=TRUE-----------------------
library("looking4clusters")

## ----echo=TRUE, message=FALSE, warning=FALSE----------------------------------
# Load sample data from scRNAseq package
library(scRNAseq)
sce <- ReprocessedAllenData("tophat_counts")
counts <- assay(sce, "tophat_counts")

# Perform dimensional reduction and an automatic cluster identification
obj <- looking4clusters(t(counts), groups=colData(sce)[,'dissection_s'])

# Output interactive visualization
l4chtml(obj)

## ----echo=FALSE, out.width='100%'---------------------------------------------
knitr::include_graphics("auto.png")

## ----echo=TRUE, message=FALSE, warning=FALSE----------------------------------
# Create a new looking for cluster object
obj <- looking4clusters(t(counts), running_all=FALSE)

# Add a sample clasification from input data
groups <- colData(sce)[,'dissection_s']
obj <- addcluster(obj, groups, myGroups=TRUE)

# Perform a PCA and TSNE and add to the object as a dimensional reduction layout
libsizes <- colSums(counts)
size.factors <- libsizes/mean(libsizes)
logcounts(sce) <- log2(t(t(counts)/size.factors) + 1)

pca_data <- prcomp(t(logcounts(sce)), rank=50)
obj <- addreduction(obj, pca_data$x[,1:2], "PCA")

library(Rtsne)
tsne_data <- Rtsne(pca_data$x[,1:50], pca = FALSE)
obj <- addreduction(obj, tsne_data$Y, "TSNE")

# Output interactive visualization
l4chtml(obj)

## ----echo=FALSE, out.width='100%'---------------------------------------------
knitr::include_graphics("manual.png")

## ----echo=TRUE, message=FALSE, warning=FALSE----------------------------------
# Adding PCA and TSNE to the object
reducedDims(sce) <- list(PCA=pca_data$x, TSNE=tsne_data$Y)

# Create a looking4clusters object from a SingleCellExperiment object
obj <- looking4clusters(sce, groups="dissection_s")

# Output interactive visualization
l4chtml(obj)

## ----echo=FALSE, out.width='100%'---------------------------------------------
knitr::include_graphics("sce.png")

## ----echo=TRUE, message=FALSE, warning=FALSE, eval=FALSE----------------------
# library(Seurat)
# library(Matrix)
# 
# # Load sample data from ZilionisLungData
# lung <- ZilionisLungData()
# immune <- lung$Used & lung$used_in_NSCLC_immune
# lung <- lung[,immune]
# lung <- lung[1:10000,1:1000]
# 
# exp_mat <- Matrix(counts(lung),sparse = TRUE)
# colnames(exp_mat) <- paste0(colnames(exp_mat), seq(1,ncol(exp_mat)))
# 
# # Create a new Seurat object
# seurat_object <- CreateSeuratObject(counts = exp_mat,
#                                     project = "Zilionis_immune")
# 
# # Seurat data processing steps
# seurat_object <- NormalizeData(seurat_object)
# seurat_object <- ScaleData(seurat_object, features = rownames(seurat_object))
# 
# seurat_object <- FindVariableFeatures(seurat_object)
# seurat_object <- RunPCA(seurat_object,
#     features = VariableFeatures(object = seurat_object))
# 
# # Create a looking4clusters object from a Seurat object
# obj <- looking4clusters(seurat_object)
# 
# # Output interactive visualization
# l4chtml(obj)

## ----echo=FALSE, out.width='100%'---------------------------------------------
knitr::include_graphics("seurat.png")

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

# Multi Dimensional Scaling

run_mds <- function(object,threads=NULL){

    data <- object$data

    # Distance matrix
    if(requireNamespace("parallelDist",quietly=TRUE)){
        distMatrix <- parallelDist::parDist(data,
            method="canberra", threads=threads)
    }else{
        message("installing 'parallelDist' can improve performance")
        distMatrix <- dist(data,method="canberra")
    }

    # Classical Multi Dimensional Scaling (cMDS)
    cmds <- cmdscale(distMatrix, k=2)
    colnames(cmds) <- c("cMDS1","cMDS2")

    return(addreduction(object,cmds,"cmds"))
}

library(looking4clusters)

object <- looking4clusters(iris[,1:4],running_all=FALSE)
object <- addcluster(object,iris[,5],"species",myGroups=TRUE)
PCAcomponents <- prcomp(data.matrix(iris[,1:4]),scale=FALSE)
pca<-PCAcomponents$x[,1:2]
object <- addreduction(object,pca,"pca")
l4chtml(object,includeData=TRUE,directory="l4c_saved")

# get clusters (auto)
obj <- looking4clusters(iris[,1:4], groups=iris[,5])
print(object)

# single-cell RNAseq
library(scRNAseq)
sce <- ReprocessedAllenData("tophat_counts")
counts <- assay(sce, "tophat_counts")

obj <- looking4clusters(t(counts), groups=colData(sce)[,'dissection_s'],
    components=TRUE)
l4chtml(obj, includeData=TRUE)

# SingleCellExperiment
libsizes <- colSums(counts)
size.factors <- libsizes/mean(libsizes)
logcounts(sce) <- log2(t(t(counts)/size.factors) + 1)

pca_data <- prcomp(t(logcounts(sce)), rank=50)

reducedDims(sce) <- list(PCA=pca_data$x)

obj <- looking4clusters(sce, groups="dissection_s")
l4chtml(object,directory="l4c_saved")

# seurat
library(Seurat)
library(Matrix)

test_mat <- Matrix(as.matrix(iris[,1:4]),sparse=T)
rownames(test_mat) <- paste0("sample",seq_len(nrow(test_mat)))

seurat_object <- CreateSeuratObject(counts = test_mat)
seurat_object <- NormalizeData(seurat_object)
seurat_object <- ScaleData(seurat_object, features = rownames(seurat_object))

seurat_object[["CITE"]] <- CreateAssayObject(counts = test_mat[1:6,])
seurat_object <- NormalizeData(seurat_object, assay="CITE")
seurat_object <- ScaleData(seurat_object,
    features = rownames(seurat_object[["CITE"]]), assay="CITE")

seurat_object <- FindVariableFeatures(seurat_object)
seurat_object <- RunPCA(seurat_object, npcs = 2,
    features = VariableFeatures(object = seurat_object))

obj <- looking4clusters(seurat_object,assay="all")

# all 0 column
wrongmat <- matrix(c(0,0,0,0,1,3,3,2,1,2,2,1),4)
obj <- looking4clusters(wrongmat)

# all 0 row
wrongmat <- matrix(c(0,1,1,1,0,3,3,2,0,2,2,1),4)
obj <- looking4clusters(wrongmat)

# negative entries
wrongmat <- matrix(c(3,1,1,1,3,-1,-1,2,3,2,2,1),4)
obj <- looking4clusters(wrongmat)

# NMF: Nonnegative Matrix Factorization

run_nmf <- function(object){
    if(requireNamespace("NMF",quietly=TRUE)){
        data <- object$data
        if(!sum(colSums(data)==0)){
            if(!sum(rowSums(data)==0)){
                if(!sum(data<0)){
                    NMFcomponents <- NMF::nmf(data, rank=2, method="brunet")
                    nmf <- NMF::basis(NMFcomponents)
                    colnames(nmf) <- c("NMF1","NMF2")
                    object <- addreduction(object,nmf,"nmf")
                }else{
                    warning(
"Your data contains some negative entries, this is not supported for nmf."
                    )
                }
            }else{
                warning(
"Your data has rows that are all zeros, this is not supported for nmf."
                )
            }
        }else{
            warning(
"Your data has columns that are all zeros, this is not supported for nmf."
            )
        }
    }else{
        warning("Install 'NMF' to get nmf dimensionality reduction.")
    }
    return(object)
}

---
title: "Interactive visualization of dimensional reduction, clustering and cell propoerties for scRNA-Seq data analysis"
author: "David Barrios, Angela Villaverde and Carlos Prieto"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{scRNA-Seq, Dimensional Reduction, Clustering and Visualization}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Getting started

`looking4clusters` is an R package distributed as part of CRAN.
To install the package, start R and enter:

```{r , echo=TRUE, message=FALSE, warning=FALSE, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("looking4clusters")
```

Once `looking4clusters` is installed, it can be loaded by the following
command.
```{r , echo=TRUE, message=FALSE, warning=FALSE, eval=TRUE}
library("looking4clusters")
```

# Introduction

looking4clusters performs interactive data visualization to facilitate the
analysis of scRNA-Seq. Input data are projected in two-dimensional
representations by applying dimensionality reduction methods such as: PCA, MDS,
t-SNE, UMAP, NMF. The representation of the data in the same interface with
interconnected graphs gives different perspectives which enable an adequate
cell classification.
The package also integrates the application of unsupervised clustering
techniques whose results can be viewed interactively in the graphical
interface. As a result, the package generates an interactive web page developed
with JavaScript that can be easily explored with a web browser. In addition to
the visualization, this interface allows the manual selection of groups,
labeling of cell entities based on processed meta-information, generation of
new graphs that show gene expression values of each cell, sample
identification, and visually comparison of samples and clusters.
Interactive visualization can be performed from a numeric matrix or a Seurat
Object.

# Interactive visualization from a numeric matrix

```{r echo=TRUE, message=FALSE, warning=FALSE}
# Load sample data from scRNAseq package
library(scRNAseq)
sce <- ReprocessedAllenData("tophat_counts")
counts <- assay(sce, "tophat_counts")

# Perform dimensional reduction and an automatic cluster identification
obj <- looking4clusters(t(counts), groups=colData(sce)[,'dissection_s'])

# Output interactive visualization
l4chtml(obj)
```

```{r echo=FALSE, out.width='100%'}
knitr::include_graphics("auto.png")
```

Alternatively you can iniltialize an object and then add clusters and
reductions
```{r echo=TRUE, message=FALSE, warning=FALSE}
# Create a new looking for cluster object
obj <- looking4clusters(t(counts), running_all=FALSE)

# Add a sample clasification from input data
groups <- colData(sce)[,'dissection_s']
obj <- addcluster(obj, groups, myGroups=TRUE)

# Perform a PCA and TSNE and add to the object as a dimensional reduction layout
libsizes <- colSums(counts)
size.factors <- libsizes/mean(libsizes)
logcounts(sce) <- log2(t(t(counts)/size.factors) + 1)

pca_data <- prcomp(t(logcounts(sce)), rank=50)
obj <- addreduction(obj, pca_data$x[,1:2], "PCA")

library(Rtsne)
tsne_data <- Rtsne(pca_data$x[,1:50], pca = FALSE)
obj <- addreduction(obj, tsne_data$Y, "TSNE")

# Output interactive visualization
l4chtml(obj)
```

```{r echo=FALSE, out.width='100%'}
knitr::include_graphics("manual.png")
```

# Interactive visualization from a SingleCellExperiment Object
```{r echo=TRUE, message=FALSE, warning=FALSE}
# Adding PCA and TSNE to the object
reducedDims(sce) <- list(PCA=pca_data$x, TSNE=tsne_data$Y)

# Create a looking4clusters object from a SingleCellExperiment object
obj <- looking4clusters(sce, groups="dissection_s")

# Output interactive visualization
l4chtml(obj)
```

```{r echo=FALSE, out.width='100%'}
knitr::include_graphics("sce.png")
```

# Interactive visualization from a Seurat Object

```{r echo=TRUE, message=FALSE, warning=FALSE, eval=FALSE}
library(Seurat)
library(Matrix)

# Load sample data from ZilionisLungData
lung <- ZilionisLungData()
immune <- lung$Used & lung$used_in_NSCLC_immune
lung <- lung[,immune]
lung <- lung[1:10000,1:1000]

exp_mat <- Matrix(counts(lung),sparse = TRUE)
colnames(exp_mat) <- paste0(colnames(exp_mat), seq(1,ncol(exp_mat)))

# Create a new Seurat object
seurat_object <- CreateSeuratObject(counts = exp_mat, 
                                    project = "Zilionis_immune")

# Seurat data processing steps
seurat_object <- NormalizeData(seurat_object)
seurat_object <- ScaleData(seurat_object, features = rownames(seurat_object))

seurat_object <- FindVariableFeatures(seurat_object)
seurat_object <- RunPCA(seurat_object,
    features = VariableFeatures(object = seurat_object))

# Create a looking4clusters object from a Seurat object
obj <- looking4clusters(seurat_object)

# Output interactive visualization
l4chtml(obj)
```

```{r echo=FALSE, out.width='100%'}
knitr::include_graphics("seurat.png")
```

# SessionInfo {-}

```{r sessionInfo}
sessionInfo()
```

\name{l4chtml}
\alias{l4chtml}
\title{Clustering determination and visualization}
\description{
\code{l4chtml} creates an html web from a 'looking4cluster' object.
}
\author{
David Barrios, Angela Villaverde and Carlos Prieto. Bioinformatics Service of
Nucleus, University of Salamanca. See \url{https://bioinfo.usal.es/}
}
\value{
The function creates a folder in your computer with an HTML document named
index.html which contains the interactive web page. This file can be directly
opened with your browser.
}

\usage{
l4chtml(x, includeData = FALSE, directory = NULL)
}
\arguments{
\item{x}{A \code{looking4cluster} object or a json generated by a
\code{looking4cluster} html web.}
\item{includeData}{If FALSE, size will be reduced but some functionalities will
be lost.}
\item{directory}{A "character" string representing the directory where the
graph will be saved.}
}
\examples{
obj <- looking4clusters(iris[,1:4], running_all=FALSE)
obj <- addcluster(obj,iris[,5],"species",myGroups=TRUE)
PCAcomponents <- prcomp(data.matrix(iris[,1:4]), scale=FALSE)
pca<-PCAcomponents$x[,1:2]
obj <- addreduction(obj,pca,"pca")
l4chtml(obj)
}

\name{looking4clusters}
\alias{looking4clusters}
\title{Clustering determination and visualization}
\author{
David Barrios, Angela Villaverde and Carlos Prieto. Bioinformatics Service of
Nucleus, University of Salamanca. See \url{https://bioinfo.usal.es/}
}
\value{
Object of class \code{looking4clusters}.
}

\usage{
looking4clusters(data, groups = NULL, assay = NULL,
    components = FALSE, running_all = TRUE, distance = "euclidean",
    agglomeration = "complete", selectedk = NULL, perplex = 30,
    maxIter = 1000, threads = NULL, force_execution = FALSE)
}
\arguments{
\item{data}{A \code{Seurat} or \code{SingleCellExperiment} object.
Alternatively, a numeric data.frame or matrix where variables are in columns
and samples are in rows.}
\item{groups}{Factor/Vector which defines an input category for each sample
which will be visualized in the output plot.}
\item{assay}{Specific assay to get data from or set data for; defaults to the
default assay.}
\item{components}{If TRUE, clustering algorithms are applied to main components
obtained with PCA.}
\item{running_all}{If TRUE, applies dimension reduction and clustering
techniques if the input is a matrix like object.}
\item{distance}{the distance measure to be used with hierarchical clustering
algorithm. This must be one of "euclidean", "maximum", "manhattan", "canberra",
"binary" or "minkowski". Any unambiguous substring can be given.}
\item{agglomeration}{the agglomeration method to be used with hierarchical
clustering algorithm. This should be (an unambiguous abbreviation of) one of
"ward.D", "ward.D2", "single", "complete", "average" (= UPGMA),
"mcquitty" (= WPGMA), "median" (= WPGMC) or "centroid" (= UPGMC).}
\item{selectedk}{Number of expected clusters given by the user. By default, the
algorithm will run clustering algorithms with a number of clusters between 2
and 10. If selectedk is specified, a range of 5 units around the 'selectedk'
will be used as number of clusters.}
\item{perplex}{The perplexity parameter used for t-SNE algorithm execution
(should not be bigger than 3 * perplexity < nrow(X)-1). This value effectively
controls how many nearest neighbors are taken into account when constructing
the embedding in the low-dimensional space (default: 30)}
\item{maxIter}{The number of iterations used for t-SNE algorithm execution
(default: 1000)}
\item{threads}{The number of CPU threads for calculating a distance matrix.
Default value is the amount of CPU cores available on the system.}
\item{force_execution}{force the execution of some methods that could cause
performance problems with large matrices.}
}
\description{
\code{looking4clusters} Creates interactive clustering visualization plots
from a \code{SingleCellExperiment} object, \code{Seurat} object or a matrix.
It can also apply dimension reduction and clustering techniques.
}
\examples{
obj <- looking4clusters(iris[,1:4], groups=iris[,5], threads = 2)
}

\name{addcluster}
\alias{addcluster}
\title{Clustering determination and visualization}
\description{
\code{addcluster} adds a dimensional reduction to a \code{looking4cluster}
object.
}
\author{
David Barrios, Angela Villaverde and Carlos Prieto. Bioinformatics Service of
Nucleus, University of Salamanca. See \url{https://bioinfo.usal.es/}
}
\value{
Object of class \code{looking4clusters}.
}

\usage{
addcluster(object, data, name=NULL, groupStatsBy=FALSE,
    myGroups=FALSE, optim_cluster=FALSE)
}
\arguments{
\item{object}{A \code{looking4cluster} object.}
\item{data}{a vector with a cluster especified per sample.}
\item{name}{a name for the dimensional reduction.}
\item{groupStatsBy}{If TRUE, this cluster will allow to group statistics.}
\item{myGroups}{If TRUE, this cluster will be initially loaded in user's custom
groups}
\item{optim_cluster}{If TRUE and there are multiple clusterizations for this
method, this will be the default.}
}
\examples{
object <- looking4clusters(iris[,1:4], running_all=FALSE)
object <- addcluster(object,iris[,5],"species",myGroups=TRUE)
}

\name{addreduction}
\alias{addreduction}
\title{Clustering determination and visualization}
\description{
\code{addreduction} adds a dimensional reduction to a \code{looking4cluster}
object.
}
\author{
David Barrios, Angela Villaverde and Carlos Prieto. Bioinformatics Service of
Nucleus, University of Salamanca. See \url{https://bioinfo.usal.es/}
}
\value{
Object of class \code{looking4clusters}.
}

\usage{
addreduction(object,data,name=NULL)
}
\arguments{
\item{object}{A \code{looking4cluster} object.}
\item{data}{a matrix with a row per sample.}
\item{name}{a name for the dimensional reduction.}
}
\examples{
object <- looking4clusters(iris[,1:4], running_all=FALSE)
PCAcomponents <- prcomp(data.matrix(iris[,1:4]), scale=FALSE)
pca<-PCAcomponents$x[,1:2]
object <- addreduction(object,pca,"pca")
}
